%{

#include "sets.cpp"
#define QUIT 777
#define YYSTYPE SET*

SETS_LIST sets;							//ᯨ᮪ 
SET I;                              //㭨ᠫ쭮 ⢮

yyparse();

%}

%start list

%token TEMP_SET
%token ID_SET
%right '='                           /* ᢠ           */
%left '+' '-'                        /* 쥤, ࠧ  */
%left '*'                            /* 祭            */
%left '!'                            /*  (栭) */

%%

list:
	{ prompt(); }
	| list '\n'
	{
		prompt();
		while(sets.del("__TEMP"));
	}
	| list stat '\n'
	{
		while(sets.del("__TEMP"));     /* 㤠 ६  */
	}											 /* ᫥  窨        */
	| list error '\n'
	{
		yyerrok;
		while(sets.del("__TEMP"));
		prompt();
	}
	;

stat:
	set
	{
		printf("RESULT : ");
		if(strcmp($1->name, "__TEMP"))
			$1->print();
		else
			$1->print_members();         /* ᫨ . ६     */
		printf("\n");
		prompt();
	}
	;

set:
	TEMP_SET            { $$ = $1; }
	| ID_SET            { $$ = $1; }
	| set '+' set
	{
		$$ = set_unite($1, $3);
		sets.add($$);
		$$->new_name("__TEMP");
	}
	| set '-' set
	{
		$$ = set_sub($1, $3);
		sets.add($$);
		$$->new_name("__TEMP");
	}
	| set '*' set
	{
		$$ = set_inter($1, $3);
		sets.add($$);
		$$->new_name("__TEMP");
	}
	| '!' set
	{
		$$ = set_sub(&I, $2);
		sets.add($$);
		$$->new_name("__TEMP");
	}
	| '(' set ')'       { $$ = $2; }
	| ID_SET '=' set
	{
		set_duplicate($1, $3);
		$$ = $1;
	}
	;

%%
#include <stdio.h>
#include <ctype.h>
#include <conio.h>
char s[256];                              //

void prompt()                             //뢥 ᪠
{
  fprintf(stdout, "READY> ");
}

void warning(char* s, char* t)            //뢥 ।०
{
	fprintf(stderr, "%s", s);
	if (t)
		fprintf(stderr, " %s", t);
	fprintf(stderr, "\n");
}

void yyerror(char* s)             //  yacc syntax error
{
	warning (s, (char *) 0);
}


void main()
{
	fprintf(stdout, "\n****************************************************\n");
	fprintf(stdout, "*                                                  *\n");
	fprintf(stdout, "*   ணࠬ 믮 ᫥騥 樨      *\n");
	fprintf(stdout, "*   ⢠ :                                  *\n");
	fprintf(stdout, "*                                                  *\n");
	fprintf(stdout, "*   +         쥤                          *\n");
	fprintf(stdout, "*   -         ࠧ                             *\n");
	fprintf(stdout, "*   *         祭                          *\n");
	fprintf(stdout, "*   !           㭨ᠫ쭮         *\n");
	fprintf(stdout, "*   =         ᢠ                         *\n");
	fprintf(stdout, "*                                                  *\n");
	fprintf(stdout, "*   printall  뢥  ࠭  ⢠       *\n");
	fprintf(stdout, "*   Ctrl+z    室  ணࠬ                   *\n");
	fprintf(stdout, "*                                                  *\n");
	fprintf(stdout, "****************************************************\n\n\n");
	yyparse();
	fprintf(stdout, "\n****************************************************\n");
	fprintf(stdout, "*                                                  *\n");
	fprintf(stdout, "*            ᯥ譮 襭 ࠡ !          *\n");
	fprintf(stdout, "*                                                  *\n");
	fprintf(stdout, "****************************************************\n");
}

int yylex()
{
	int c, i;

	while ((c=getchar()) == ' ' || c == '\t' );
	if (c == EOF) return 0;

	if (isalpha(c))
	{
		SET* pset;
		ungetc(c, stdin);
		for(i =0; isalpha(c = getchar()); i++) s[i] = c;  //⠥ 䨪 -
		if(!strcmp(s, "printall"))        //᫨   ᯥ⪨
		{                                 // ᯥ -
			sets.print();
			return c;
		}
		ungetc(c, stdin);
		s[i] = 0;
		pset = sets.find(s);
		if(pset == 0)              //᫨ -  ⠪   
		{                          //ᮧ , 塞  ᯨ᮪
			pset = new SET;
			pset->new_name(s);
			sets.add(pset);
		}
		yylval = pset;
		return ID_SET;
	}

	if (c == '{')         // ⨫ ६ -
	{
		SET* pset = new SET;
		pset->new_name("__TEMP");
		sets.add(pset);         //  - ᯨ᮪
		while((c = getchar()) != '}')
		{
			ungetc(c, stdin);
			while(!(isalpha(c = getchar()) || isdigit(c)) && (c != '}'));
			ungetc(c, stdin);
			for(i =0; isalpha(c = getchar()) || isdigit(c); i++) s[i] = c;
			s[i] = 0;
			ungetc(c, stdin);
			if(i == 0) continue; //- ⮥
			pset->add(s);        // ६ -
			I.add(s);            //塞 㭨ᠫ쭮 -
		}
		yylval = pset;
		return TEMP_SET;
	}

	return c;
}

