#include <string.h>
#include <stdio.h>

struct MEMBER                 //童 -
{
	char* name;
	MEMBER* next;
};

struct SET                     // ⢮
{
	MEMBER* members;            //  童 -
	char* name;                 //  -
	void new_name(char*);       // ᢮ -  
	void add(char*);            //   -  童
	void del(char*);            // 㤠
	void print();               //  -
	void print_members();       //  ⮫쪮 童 -
	SET();
	~SET();
};

void SET::new_name(char* s)
{
	delete name;
	name = strdup(s);
}

SET::SET()
{
	members = 0;
	name = new char[1];
	name[0] = 0;
}

void SET::add(char* s)
{
	MEMBER* temp = members, *cur;
	for(cur = members; cur; cur = cur->next)
	{
		if (!strcmp(cur->name, s)) break;
	}
	if(cur) return ;            //ᮢ ,   
	members = new MEMBER;
	members->next = temp;
	members->name = strdup(s);
};

void SET::del(char* s)
{
	MEMBER* cur, *prev = 0;
	for(cur = members; cur; cur = cur->next)
	{
		if (!strcmp(cur->name, s)) break;
		prev = cur;
	}
	if (cur == 0) return ;              //᫨ ⠪ 童    室
	if (prev)
		prev->next = cur->next;
	else
		members = members->next;
	delete cur->name;
	delete cur;                         //㤠塞  童
};

void SET::print()
{
	printf("%s = { ", name);
	for(MEMBER *cur = members; cur != 0; cur = cur->next)
		printf("%s ", cur->name);
	printf("}");
}

void SET::print_members()
{
	printf("{ ");
	for(MEMBER *cur = members; cur != 0; cur = cur->next)
		printf("%s ", cur->name);
	printf("}");
}


void SET::~SET()
{
	delete name;
	for(MEMBER* temp, *cur = members; cur != 0;)  // 㭨⮦ -
	{                                             //㤠塞   童
		temp = cur->next;
//		printf("deleting %s\n", cur->name);
		delete cur->name;
		delete cur;
		cur = temp;
	}
};

void set_duplicate(SET* pset1, SET* pset2)   // ᯮ⥫쭠 - 
{                                            //  童 ண -  ࢮ
	MEMBER* temp;
	for(MEMBER* cur = pset1->members; cur;) //㤠塞  童 ࢮ -
	{
		temp = cur->next;
		delete cur->name;
		delete cur;
		cur = temp;
	}
	pset1->members = 0;
	temp = pset2->members;
	while(temp)
	{
		pset1->add(temp->name);     //㥬  童 2  -  ࢮ
		temp = temp->next;
	}
}


SET* set_unite(SET* pset1, SET* pset2) //頥 㪠⥫   -
{                                      //ࠢ 쥤 1   2  .
	SET* pset = new SET;
	MEMBER* temp = pset1->members;
	while(temp)
	{
		pset->add(temp->name);
		temp = temp->next;
	}
	temp = pset2->members;
	while(temp)
	{
		pset->add(temp->name);
		temp = temp->next;
	}
	return pset;
}

SET* set_sub(SET* pset1, SET* pset2)//頥 㪠⥫   -
{                                   //ࠢ ⠭ 2  -  1 
	SET* pset = new SET;
	MEMBER* temp = pset1->members;
	while(temp)
	{
		pset->add(temp->name);
		temp = temp->next;
	}
	temp = pset2->members;
	while(temp)
	{
		pset->del(temp->name);
		temp = temp->next;
	}
	return pset;
}


SET* set_inter(SET* pset1, SET* pset2)//頥 㪠⥫   -
{                                     //ࠢ 祭 2 .
	SET* pset = new SET;
	MEMBER* temp1 = pset1->members, *temp2 = pset2->members;
	while(temp1)
	{
		while(temp2)
		{
			if(!strcmp(temp1->name, temp2->name))
			{
				pset->add(temp1->name);
				break;
			}
			temp2 = temp2->next;
		}
		temp1 = temp1->next;
		temp2 = pset2->members;
	}
	return pset;
}

//------------------------------------------
struct SETS_LIST_MEMBER
{
	SET* set;
	SETS_LIST_MEMBER* next;
	~SETS_LIST_MEMBER();
};

SETS_LIST_MEMBER::~SETS_LIST_MEMBER()
{
//	printf("deleting %s\n", set->name);
	delete set;
	next = 0;
}


struct SETS_LIST              //ᯨ᮪ 
{
	SETS_LIST_MEMBER* pslm;
	SETS_LIST();
	~SETS_LIST();
	void add(SET*);            // -  ᯨ᮪
	SET* find(char*);          //頥 㪠⥫  -  ⠪ 
	int del(char* s);          //㤠 -  ⠪ 
	void print();              //  -
};


SETS_LIST::SETS_LIST()
{
	pslm = 0;
}

SETS_LIST::~SETS_LIST()
{
	for(SETS_LIST_MEMBER* temp = pslm, *temp2; temp; temp = temp2)
	{
		temp2 = temp->next;
		delete temp;
	}
}

void SETS_LIST::add(SET* pset)
{
	SETS_LIST_MEMBER* temp = new SETS_LIST_MEMBER;
	temp->set = pset;
	temp->next = pslm;
	pslm = temp;
}

SET* SETS_LIST::find(char* s)
{
	for(SETS_LIST_MEMBER* temp = pslm ;temp ; temp = temp->next)
	{
		if (!strcmp(temp->set->name, s)) break;
	}
	if(temp) return temp->set;            //ᮢ 
	return 0;
}

int SETS_LIST::del(char* s)
{
	SETS_LIST_MEMBER* temp = pslm, *temp2;
	if (!pslm) return 0;
	if (!strcmp(pslm->set->name, s))
	{
		temp = pslm->next;
		delete pslm;
		pslm = temp;
		return 1;
	}
	for(; temp->next; temp = temp->next)
	{
		if (!strcmp(temp->next->set->name, s)) break;
	}
	if(temp->next)            //ᮢ 
	{
		temp2= temp->next->next;
		delete temp->next;
		temp->next = temp2;
		return(1);
	}
	else return(0);          // 
}

void SETS_LIST::print()
{
	SETS_LIST_MEMBER* temp = pslm;
	for(;temp; temp = temp->next)
	{
		printf("\n");
		temp->set->print();
	}
	printf("\n");
	printf("\n");
}
